package com.hai.dao;

import com.hai.entity.HighDiscountAgentRel;
import com.hai.entity.HighDiscountAgentRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountAgentRelMapper extends HighDiscountAgentRelMapperExt {
    @SelectProvider(type=HighDiscountAgentRelSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountAgentRelExample example);

    @DeleteProvider(type=HighDiscountAgentRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountAgentRelExample example);

    @Delete({
        "delete from high_discount_agent_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_discount_agent_rel (discount_id, agent_id, ",
        "stock_count, create_time, ",
        "`status`, qr_code, ",
        "ext_1, ext_2, ext_3)",
        "values (#{discountId,jdbcType=BIGINT}, #{agentId,jdbcType=BIGINT}, ",
        "#{stockCount,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{qrCode,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountAgentRel record);

    @InsertProvider(type=HighDiscountAgentRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountAgentRel record);

    @SelectProvider(type=HighDiscountAgentRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="stock_count", property="stockCount", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountAgentRel> selectByExample(HighDiscountAgentRelExample example);

    @Select({
        "select",
        "id, discount_id, agent_id, stock_count, create_time, `status`, qr_code, ext_1, ",
        "ext_2, ext_3",
        "from high_discount_agent_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_id", property="discountId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="stock_count", property="stockCount", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountAgentRel selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighDiscountAgentRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountAgentRel record, @Param("example") HighDiscountAgentRelExample example);

    @UpdateProvider(type=HighDiscountAgentRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountAgentRel record, @Param("example") HighDiscountAgentRelExample example);

    @UpdateProvider(type=HighDiscountAgentRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountAgentRel record);

    @Update({
        "update high_discount_agent_rel",
        "set discount_id = #{discountId,jdbcType=BIGINT},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "stock_count = #{stockCount,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "qr_code = #{qrCode,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighDiscountAgentRel record);
}